package com.sf.payment.domain;

import lombok.Data;

/**
 * 功能描述:
 *
 * @author a_kun
 * @date 2024/4/17 14:41
 */
@Data
public class HuaweiQueryResponse {

    /**
     * 返回码。
     * •	0：成功。
     * •	其他：失败，具体请参见错误码
     */
    private String responseCode;

    /**
     * 响应描述。
     */
    private String responseMessage;

    /**
     * 包含已购订单相关状态信息的JWS格式数据。可参见对返回结果验签解码验签获取相关订单状态信息的JSON字符串，其包含的参数具体请参见表PurchaseOrderPayload说明。
     */
    private String jwsPurchaseOrder;

    /**
     * 包含已购订阅相关状态信息的JWS格式数据。可参见对返回结果验签解码验签获取相关订阅状态信息的JSON字符串，其包含的参数请参见SubGroupStatusPayload
     */
    private String jwsSubGroupStatus;
}
