package com.sf.service.deployment.service;

import com.sf.service.deployment.domain.DeploymentServicePublish;

import java.util.List;

/**
 * 发布列表Service接口
 * 
 * @author ztzh
 * @date 2024-04-19
 */
public interface IDeploymentServicePublishService 
{
    /**
     * 查询发布列表
     * 
     * @param id 发布列表主键
     * @return 发布列表
     */
    public DeploymentServicePublish selectDeploymentServicePublishById(Long id);

    /**
     * 查询发布列表列表
     * 
     * @param deploymentServicePublish 发布列表
     * @return 发布列表集合
     */
    public List<DeploymentServicePublish> selectDeploymentServicePublishList(DeploymentServicePublish deploymentServicePublish);

    /**
     * 新增发布列表
     * 
     * @param deploymentServicePublish 发布列表
     * @return 结果
     */
    public int insertDeploymentServicePublish(DeploymentServicePublish deploymentServicePublish);

    /**
     * 修改发布列表
     * 
     * @param deploymentServicePublish 发布列表
     * @return 结果
     */
    public int updateDeploymentServicePublish(DeploymentServicePublish deploymentServicePublish);

    /**
     * 批量删除发布列表
     * 
     * @param ids 需要删除的发布列表主键集合
     * @return 结果
     */
    public int deleteDeploymentServicePublishByIds(Long[] ids);

    /**
     * 删除发布列表信息
     * 
     * @param id 发布列表主键
     * @return 结果
     */
    public int deleteDeploymentServicePublishById(Long id);

    public int publish(DeploymentServicePublish deploymentServicePublish) throws Exception;

    public int soldOut(DeploymentServicePublish deploymentServicePublish);
}
