import request from '@/utils/request'

// 查询白名单列表列表
export function listWhitelist (query) {
  return request({
    url: '/deployment/whitelist/list',
    method: 'get',
    params: query
  })
}

// 查询白名单列表详细
export function getWhitelist (id) {
  return request({
    url: '/deployment/whitelist/' + id,
    method: 'get'
  })
}

// 新增白名单列表
export function addWhitelist (data) {
  return request({
    url: '/deployment/whitelist',
    method: 'post',
    data: data
  })
}

// 修改白名单列表
export function updateWhitelist (data) {
  return request({
    url: '/deployment/whitelist',
    method: 'put',
    data: data
  })
}

// 删除白名单列表
export function delWhitelist (id) {
  return request({
    url: '/deployment/whitelist/' + id,
    method: 'delete'
  })
}
// 查询白名单成员列列表
export function listWhitelistMember (query) {
  return request({
    url: '/deployment/whitelistMember/list',
    method: 'get',
    params: query
  })
}

// 查询白名单成员列详细
export function getWhitelistMember (id) {
  return request({
    url: '/deployment/whitelistMember/' + id,
    method: 'get'
  })
}

// 新增白名单成员列
export function addWhitelistMember (data) {
  return request({
    url: '/deployment/whitelistMember',
    method: 'post',
    data: data
  })
}

// 修改白名单成员列
export function updateWhitelistMember (data) {
  return request({
    url: '/deployment/whitelistMember',
    method: 'put',
    data: data
  })
}

// 删除白名单成员列
export function delWhitelistMember (id) {
  return request({
    url: '/deployment/whitelistMember/' + id,
    method: 'delete'
  })
}



// 发布白名单
export function publishWhitelist (id) {
  return request({
    url: '/deployment/whitelist/publish/' + id,
    method: 'get',
  })
}

// 下架白名单
export function soldOutWhitelist (id) {
  return request({
    url: '/deployment/whitelist/sold/out/' + id,
    method: 'get',
  })
}

// 批量上传白名单
export function importWhitelist (data) {
  return request({
    url: 'deployment/whitelistMember/batch/import',
    method: 'post',
    data: data
  })
}
